#!/usr/bin/env python
# -*- coding: utf-8 -*- 
#     ________________________________________________
#    /_______________________________________________/|
#    |                                              |*|
#    |   name:         Baltazar                     |*|
#    |   version:      0.2.1                        |*|
#    |   Last Change:  19. August 2009.             |*|
#    |                                              |*|
#    |   made by:      Jovicic Nemanja (c) 2009.    |*|
#    |   email:        nemanja.jovicic@hotmail.com  |*|
#    |   homepage:     http://www.njsoft.iz.rs      |*|
#    |                                              |*|
#    |   made in Serbia                             |*|
#    |______________________________________________|/

try:
   import re
   import time
   import sys
   import os

   import pango
   from sys import argv
   import gtk
   import gtk.glade
   import pygtk
   pygtk.require("2.0")
   import gobject
   print 'Dependencies... [LOADED]'
   
   #import threading
except:
   print "Check dependencies! Import library error!... [TERMINATED]"
   exit(1)
try:
   from plugins import *
   print 'Plugins...\t[LOADED]'
except:
   print 'Error plugins...\t[TERMINATED]'
   exit(1)
print 'Starting...\t[SUCESS]'

class Baltazar():
   
   # putanja do izvrsnog fajla
   if argv[0].find('/') == argv[0].rfind('/'):
      path =""
   else:
      path = argv[0][:argv[0].rfind('/')].strip()+'/'

   # lista u kojoj se nalaze svi linkovi
   # prvi clan je string linka, a drugi 1 ili 0 u zavisnosti da li je skinut il ne
   links=[]

   # Ukupan broj linkova koji se nalaze u links listi
   ukupnoLinkova=-1
   
   # Folder u koji se downloaduje
   dwnDir=os.getenv('HOME')

   # Putanja do fajla - koristi se za brisanje kod Stop
   filePath=""

   numK=8 #32/4 zbog tajmera

   # Default ekstenzija za youtube
   YTubeExt=".flv"

   # Da li je zapochet download
   progress = False

   aboutWindow=None
   settingsWindow=None

   def run(self):
      
      # Ucitavanje glade fajla
      gladefile = str(self.path)+"baltazar.glade"  
      self.wTree = gtk.glade.XML(gladefile) 
      
      #  Ucitavanje komponenti
      self.mainWindow = self.wTree.get_widget("MainWindow")
      self.editLinks = self.wTree.get_widget("textview_links")
      self.treeview = self.wTree.get_widget("treeviewLinks")
      self.addVBox = self.wTree.get_widget("addBox")
      self.settingsVBox = self.wTree.get_widget("settingsBox")
      self.statusBar = self.wTree.get_widget("statusBar")
      self.progressbar = self.wTree.get_widget("progressbar")
      self.folderChooser = self.wTree.get_widget("filechooserbutton")
      self.noKBSpeed = self.wTree.get_widget("noKbSpeed")
      self.comboBoxYTubeExt = self.wTree.get_widget("comboboxYTubeExt")

      # Povezivanje signala i njihovih funkcija
      dic =   { 
         "on_MainWindow_destroy" : self.Quit,#gtk.main_quit,
         
         "on_toolbutton_add_clicked" : self.showAddVBox,
         "on_buttonAddLinksCancel_clicked" : self.hideAddVBox,
         
         "on_buttonAddLinksOk_clicked" : self.addLinks,
         "on_toolbutton_download_clicked" : self.buttonDownload, 
         
         "on_toolbuttonStop_clicked" : self.stopDownload,

         "on_toolbutton_clear_clicked" : self.clearList,

         "on_toolbutton_settings_clicked" : self.showSettingsVBox,
         "on_buttonSettingsCancel_clicked" : self.hideSettingsVBox,
         "on_buttonSettingsOk_clicked" : self.applySettings,

         "on_toolbutton_about_clicked" : self.aboutShow,
         "on_open_activate" : self.openLinksFromFile,
         "on_quit_activate" : self.Quit,
         "on_about_activate" : self.aboutShow
         }
      self.wTree.signal_autoconnect(dic)
      
      # podesavanja pocetnih vrednosti
      self.setup_treeView()
      
      self.getSettings()
      
      # iteratori za rad sa treeview-om
      self.iter   = None
      
      # start prozora
      gtk.main()

#-----------------------------------------------------------------------------------

   def showAddVBox(self,event=0):
      # prikazuje box u kome se upisuju linkovi
      self.addVBox.show()


   def hideAddVBox(self,event=0):
      # sakriva box u kome se upisuju linkovi
      self.addVBox.hide()
      buff=gtk.TextBuffer()
      buff.set_text("")
      self.editLinks.set_buffer(buff)
#-----------------------------------------------------------------------------------

   def showSettingsVBox(self, event=0):
      # prikazuje settings box
      self.settingsVBox.show()
      # podeshavanje polja
      self.folderChooser.set_current_folder(self.dwnDir)
      self.noKBSpeed.set_value(self.numK*4) #*4 zbog tajmera

      if self.YTubeExt == ".flv":
         self.comboBoxYTubeExt.set_active(0)
      else:
         self.comboBoxYTubeExt.set_active(1)
#-----------------------------------------------------------------------------------

   def hideSettingsVBox(self,event=0):
      # sakriva settings box
      self.settingsVBox.hide()
      buff=gtk.TextBuffer()
      buff.set_text("")
      self.editLinks.set_buffer(buff)

   def applySettings(self,event=0):

      # menjanje brzine downloada (ide/4 jer tajmer ide na 1/4 sekunde)
      self.numK = self.noKBSpeed.get_value_as_int()/4

      # menjanje foldera
      self.dwnDir = self.folderChooser.get_filename()+"/"

      a = self.comboBoxYTubeExt.get_active()
      if a == 0:
         self.YTubeExt = ".flv"
      elif a == 1:
         self.YTubeExt = ".mp4"

      self.writeSettingsToFile()
      self.hideSettingsVBox()
#-----------------------------------------------------------------------------------

   def getSettings(self):
      # Uchitava podeshavanja iz fajla ako postoji

      settingsDir = os.getenv('HOME')
      settingsDir = settingsDir+"/.baltazar/"
      settingsFile = settingsDir+"settings"

      if not os.path.isdir(settingsDir):
         os.system("mkdir "+settingsDir)			

         self.setDefaultSettings()

      elif not os.path.isfile(settingsFile):
         self.setDefaultSettings()

      else:
         data = open(settingsFile).read()

         try:
            self.dwnDir = self.getBetween(data,"<path>","</path>")
            self.numK = int(self.getBetween(data,"<speed>","</speed>"))/4 #/4 zbog tajmera
            self.YTubeExt =self.getBetween(data,"<youtubeExt>","</youtubeExt>")

            if self.numK<1:
               self.numK=8

            if self.YTubeExt != ".flv" and self.YTubeExt != ".mp4":
               self.YTubeExt = ".flv"

            if not os.path.isdir(self.dwnDir):
               self.dwnDir=os.getenv('HOME')

         except:
            self.setDefaultSettings()

      print 'Settings...\t[LOADED]'
#-----------------------------------------------------------------------------------

   def setDefaultSettings(self):
      # Podeshava default podeshavanja

      self.dwnDir=os.getenv('HOME')
      self.numK=8 #32/4 zbog tajmera
      self.YTubeExt=".flv"

      self.writeSettingsToFile()
#-----------------------------------------------------------------------------------

   def writeSettingsToFile(self):
      # Upisuje podeshavanja u fajl

      settingsFile = os.getenv('HOME')
      settingsFile = settingsFile+"/.baltazar/settings"

      f =  open(settingsFile,"w") # open for for write
      f.write("<path>"+self.dwnDir+"</path>\n<speed>"+str(self.numK*4)+"</speed>\n<youtubeExt>"+self.YTubeExt+"</youtubeExt>")
      f.close()
#-----------------------------------------------------------------------------------

   def openLinksFromFile(self, event):
      # Otvara linkove iz fajla
      
      # Ucitavanje komponenti
      self.importDialog = self.wTree.get_widget("importWindow")
      response = self.importDialog.run()
      if response == gtk.RESPONSE_OK:
         f = open(self.importDialog.get_filename(),"r")

      self.importDialog.hide()

      if self.links == []:
         iterNaZadnjeMesto=False
      else:    
         iterNaZadnjeMesto=True
      j=0
      for line in f:
         line = line.rstrip()
         objekat = self.getObjekat(line)
         if not line=="" and not line=="\n" and objekat!=None:
            self.links.append([line,"0"])
            self.last = self.insert_row(self.treemodel, None, objekat.getTypeImage(line), objekat.getImeFajla(line), 0, "Ready..")
            j+=1
            self.ukupnoLinkova+=1

      if self.progress == False:
         if iterNaZadnjeMesto:
            self.iter = self.treemodel.iter_next(self.iter)
         else:    
            self.iter = self.treemodel.get_iter_first()

      text = "Added "+str(j)+" links..."
      self.statusBar.push(0,text)

      return False
#-----------------------------------------------------------------------------------  

   def addLinks(self,event=0):
      # klik na Ok dugme kod dodavanja linkova
      
      textBuff=self.editLinks.get_buffer()
      br_linkova=textBuff.get_line_count()      

      if self.links == []:
         iterNaZadnjeMesto=False
      else:    
         iterNaZadnjeMesto=True
      i=0
      j=0
      while i<br_linkova-1:

         start=textBuff.get_iter_at_line(i)
         end=textBuff.get_iter_at_line(i+1)
         text= textBuff.get_text(start,end).rstrip() #rstrip ide zbog \n na kraju svakog reda...

         objekat = self.getObjekat(text)

         if not text=="" and objekat!=None:
            j+=1
            self.links.append([text,"0"])
            self.last = self.insert_row(self.treemodel, None, objekat.getTypeImage(text), objekat.getImeFajla(text), 0, "Ready..")
            self.ukupnoLinkova+=1
            
         i+=1
         
      # zbog onog gore rstripa ide ponovo ovo za zadnji red jer nema '\n'
      start=textBuff.get_iter_at_line(i)
      end=textBuff.get_end_iter()
      text= textBuff.get_text(start,end)
      
      objekat = self.getObjekat(text)
      
      if not text=="" and objekat!=None:
         j+=1
         self.links.append([text,"0"])
         self.last = self.insert_row(self.treemodel, None, objekat.getTypeImage(text), objekat.getImeFajla(text), 0, "Ready..")
         self.ukupnoLinkova+=1
         
      self.hideAddVBox()
      
      text = "Added "+str(j)+" links..."
      self.statusBar.push(0,text)


      #try:
      #   a=self.objekat #ovo je uradjeno da ode u except ako objekat ne postoji
      #   a=self.dwnTimer
      #   a=self.rapidTimer
      #except:
      if self.progress == False:
         if iterNaZadnjeMesto:
            self.iter = self.treemodel.iter_next(self.iter)
         else:    
            self.iter = self.treemodel.get_iter_first()

#-----------------------------------------------------------------------------------

   def getObjekat(self, link):
      # vraca objekat (youtube, rapidshare) na osnovu linka
      
      if link.find("youtube")>1:
         return Youtube()
      elif link.find("rapidshare")>1:
         return Rapid()
      else:
         return None
#-----------------------------------------------------------------------------------

   def setup_treeView(self):
      # podesavanje treeviewa za treemodel
      
      self.treemodel = gtk.ListStore(gtk.gdk.Pixbuf, str, float, str)
      self.treeview.set_model(self.treemodel)
      self.treeview.set_headers_visible(True)
      
      tt=gtk.CellRendererText()
      tt.set_property("xalign",0.5)
      
      c=gtk.TreeViewColumn("Type", gtk.CellRendererPixbuf(), pixbuf = 0)
      c.set_resizable(True)
      c.set_min_width(50)
      c.set_max_width(150)
      c.set_alignment(0.5)
      self.treeview.append_column(c)
      
      c=gtk.TreeViewColumn("File", tt, text = 1)
      c.set_resizable(True)
      c.set_min_width(100)
      c.set_max_width(200)
      c.set_alignment(0.5)
      self.treeview.append_column(c)
      
      c=gtk.TreeViewColumn("Progress", gtk.CellRendererProgress(), value=2)
      c.set_resizable(True)
      c.set_min_width(150)
      c.set_max_width(300)
      c.set_alignment(0.5)
      self.treeview.append_column(c)
      
      c=gtk.TreeViewColumn("Status", tt, text = 3)
      c.set_resizable(True)
      c.set_min_width(50)
      c.set_max_width(150)
      c.set_alignment(0.5)
      self.treeview.append_column(c)         
#-----------------------------------------------------------------------------------      

   def insert_row(self, model, parent, type_image, file, progress, status):
      # ubacuje novi red u treeview
      
      iter = model.append()
      model.set_value(iter, 0, type_image)
      model.set_value(iter, 1, file)
      model.set_value(iter, 2, progress)
      model.set_value(iter, 3, status)
      return iter
#-----------------------------------------------------------------------------------

   def Quit(self,event=0):
      # funkcija za clean memorije i gasenje
      
      try:
         # brisanje objekta
         del self.objekat
      except:
         pass
      try:
         self.importDialog.destroy()
      except:
         pass
      try:
         self.aboutWindow.destroy()
      except:
         pass

      print 'Good Bye...\t[ QUIT ]'
      gtk.main_quit()
      
#-----------------------------------------------------------------------------------
   
   def buttonDownload(self,event=0):
      # klik na dugme download

      #try:
      #   a = self.objekat
      if self.progress == True:
         print "Already in progress..."

      #except:
      else:
         if self.ukupnoLinkova>-1:
         
            prviSpremniLink = self.findFirstLink()
            if prviSpremniLink>-1:            
               
               self.progress = True

               link = self.links[prviSpremniLink][0]
            
               self.objekat = self.getObjekat(link)
               
               if self.objekat.__class__.__name__ == "Youtube":
                  self.objekat.setExt(self.YTubeExt)

               text = "Download is starting..."
               self.statusBar.push(0, text)

               respond = self.objekat.proslediLink(link, self.dwnDir)
               self.odradiPreDownlodada(respond)
               

            elif prviSpremniLink==-1: 
               text = "No link!"
               self.statusBar.push(0, text)
               self.progressbar.set_text("")
               self.progressbar.set_fraction(0)
             
            else:
               pass
         else:
            text = "No link!"
            self.statusBar.push(0, text)
            self.progressbar.set_text("")
            self.progressbar.set_fraction(0)         
      
#-----------------------------------------------------------------------------------

   def stopDownload(self, event=0):
      # klik na Stop dugme
      # treba prekinuti tajmere i obrisati fajl koji je delimichno skinut
      self.progress = False
      try:
         # oslobadjanje tajmera
         gobject.source_remove(self.dwnTimer)
         del self.dwnTimer

         text = "Download stopped!"
         
         self.statusBar.push(0,text)

         self.progressbar.set_text("")
         self.setTreeView(self.treemodel, self.iter, 0, "Stopped!")
         self.progressbar.set_fraction(0)

         self.fp.close()
         self.objekat.br.close()

         del self.fp
         del self.objekat

         os.remove(self.filePath)
         #self.progress = False
      except:
         pass

      try:
         # oslobadjanje tajmera
         gobject.source_remove(self.rapidTimer)
         del self.rapidTimer

         text = "Download stopped!"
         
         self.statusBar.push(0,text)

         self.progressbar.set_text("")
         self.setTreeView(self.treemodel, self.iter, 0, "Stopped!")
         self.progressbar.set_fraction(0)

         self.objekat.br.close()
         del self.objekat
         #self.progress = False
      except:
         pass
      
#-----------------------------------------------------------------------------------

   def clearList(self, event=0):
      # klik na Clear dugme

      #try:
      #   a = self.objekat
      if self.progress == True:
         text = "Stop download first!"
         self.statusBar.push(0,text)
         print text

      #except:
      else:

         self.treemodel.clear()
         del self.links[:]
         try:
            del self.iter
         except:
            pass

         self.ukupnoLinkova=-1

         text = "List cleared!"
         self.statusBar.push(0,text)

         self.progressbar.set_text("")
         self.progressbar.set_fraction(0)
      
      return None
#-----------------------------------------------------------------------------------

   def findFirstLink(self):
      # vraca redni broj prvog spremnog linka za download
      
      if self.ukupnoLinkova==-1:
         return -1 #u sluchaju prazne liste

      for i in range(self.ukupnoLinkova+1):
         if self.links[i][1]=="0":
            return i

      return -1 #u sluchaju da ne postoji     
#-----------------------------------------------------------------------------------

   def setTreeView(self, model, iter, progress, status):
      # koristi se za iteraciju sa promenljivim elementima u prikazu
      # a to su progress bar i status downloada
      if iter == None:
         iter = model.get_iter_first()      
      
      model.set_value(iter, 2, progress)
      model.set_value(iter, 3, status)
      
      return model.iter_next(iter)
#-----------------------------------------------------------------------------------
   
   def odradiPreDownlodada(self,respond):
   # funkcija koja proverava da li je youtube ili rapid i ukljuchuje tajmer za download

      class_name = self.objekat.__class__.__name__

      if class_name == "Youtube":

         fileName = self.objekat.fileName
         if respond == "Ok":
            try:
               exit = 0
               if os.stat(self.dwnDir+url.split('/')[-1]).st_size == int(self.objekat.file_size):
                  print "540"
                  exit = 1
            except:
               pass
            if exit == 1:
               #fajl ( primer.xxx )vec postoji i zato se pravi kopija ( primer (copy).xxx )
               fileName=fileName.partition('.')
               copyName=fileName[0]+" (copy)"+fileName[1]+fileName[2]
               self.filePath = self.dwnDir+copyName              

            else:
               self.filePath = self.dwnDir+fileName

            self.fp = open(self.filePath,'w')
            self.dwn_size = 0

            #pravi se tajmer za download
            self.dwnTimer = gobject.timeout_add(250, self.downloadTimer250ms)
         else:
            text = "Connecting error! Try again..."
            self.statusBar.push(0,text)
            self.badLink_connectionProblem_loadNext()

      elif class_name == "Rapid":

         if respond[0] == -1 or respond[1] == -1:
            text = "Connecting error or bad link! Try again..."
            self.statusBar.push(0,text)
            self.badLink_connectionProblem_loadNext()
            ###################################################################################

         elif respond[0] == 0:
            text = "Your IP address "+respond[1]+" is already downloading a file, try later!"
            self.statusBar.push(0, text)
            self.badLink_connectionProblem_loadNext()
            ###################################################################################

         elif respond[0] > 1:
            #pravi se tajmer chekanja od respond[1] sekundi
            self.s=respond[1] # ova promenljiva se smanjuje u tajmeru pri odbrojavanju
            self.rapidTimer = gobject.timeout_add(1000, self.rapidTimer1s,respond[0],respond[1])
#-----------------------------------------------------------------------------------   

   def downloadTimer250ms(self):
      # Tajmer u kom se radi download

         st = time.time()

         chunk = self.objekat.file.read(1024*self.numK)

         sizeOfChunk = len(chunk)
         self.dwn_size += sizeOfChunk

         dwn_size = self.dwn_size
         file_size = self.objekat.file_size

         if not chunk: 
            self.zavrsiDownloadPrebaciNaSledeci()

            return False

         speed = int( ( sizeOfChunk /( time.time() - st + 0.25 ) ) / 1024 )
 
 
         self.fp.write(chunk)
         self.fp.flush()

         percentage = dwn_size*100/int(file_size)
         eta=-1
         if speed>0:
            eta=(int(file_size)-dwn_size)/(speed*1024)
            text = "Size: "+self.convertByte(file_size)+"| DownSize: "+self.convertByte(dwn_size)+"| Speed: "+str(speed)+"KB/s | eta: "+str(eta/60)+"m "+str(eta%60)+"s"
         else:
            text = "Size: "+self.convertByte(file_size)+"| DownSize: "+self.convertByte(dwn_size)+"| Speed: "+str(speed)+"KB/s | eta: ---"
         

         self.statusBar.push(0,text)

         self.progressbar.set_text(str(percentage)+"%")
         self.setTreeView(self.treemodel, self.iter, percentage, "Downloading...")
         self.progressbar.set_fraction(float(percentage)/100)
         #percentage = (float(downloadedSize)/float(fileSize))*100
         #self.procent = percentage
         #sys.stdout.write('\r                                                                    ')
         #sys.stdout.flush()
         #sys.stdout.write('\r'+str(downloadedSize)+'/'+str(fileSize)+'  '+str(int(percentage))+'%  '+str(speed)+' kb/s  ETA:'+str(eta/60)+' min  '+str(eta%60)+' sec                        ')
         #sys.stdout.flush()
          
         #self.readDataOK=True
         return True
#-----------------------------------------------------------------------------------

   def rapidTimer1s(self, respond, seconds):

      if respond == 2:
         if self.s == 0:

            #brishe se ovaj tajmer
            try:
               # oslobadjanje tajmera
               gobject.source_remove(self.rapidTimer)
               del self.rapidTimer
            except:
               pass

            self.progress = False
            #odbrojao je sekunde sad treba da ponovo uchita 
            self.buttonDownload()
            return False

         else:
            self.s-=1

            text = "Currently a lot of users are downloading files. Wait..."
            self.statusBar.push(0,text)

            if self.s > 59:
               self.progressbar.set_text(str(self.s/60) + " m   "+str(self.s%60)+" s...")
            else:
               self.progressbar.set_text(str(self.s%60)+" s...")
            self.setTreeView(self.treemodel, self.iter, 0, "Waiting...")
            self.progressbar.set_fraction(1-self.s/float(seconds))

      elif respond == 3:
         if self.s == 0:

            #brishe se ovaj tajmer
            try:
               # oslobadjanje tajmera
               gobject.source_remove(self.rapidTimer)
               del self.rapidTimer
            except:
               pass
            self.progress = False
            #odbrojao je sekunde sad treba da ponovo uchita 
            self.buttonDownload()
            return False

         else:
            self.s-=1

            text = "Free RapidShare user must wait between two downloads..."
            self.statusBar.push(0,text)

            if self.s > 59:
               self.progressbar.set_text(str(self.s/60) + " m   "+str(self.s%60)+" s...")
            else:
               self.progressbar.set_text(str(self.s%60)+" s...")
            self.setTreeView(self.treemodel, self.iter, 0, "Waiting...")
            self.progressbar.set_fraction(1-self.s/float(seconds))

      elif respond == 4:
         if self.s == 0:

            #brishe se ovaj tajmer
            try:
               # oslobadjanje tajmera
               gobject.source_remove(self.rapidTimer)
               del self.rapidTimer
            except:
               pass

            #odbrojao je sekunde sad treba da krene download
            respond_ = self.objekat.fileDownload(self.objekat.htmlDec)         

            fileName = self.objekat.fileName
            if respond_ == "Ok":
               try:
                  exit = 0
                  if os.stat(self.dwnDir+url.split('/')[-1]).st_size == int(self.objekat.file_size):
                     exit = 1
               except:
                  pass
               if exit == 1:
                  #fajl ( primer.xxx )vec postoji i zato se pravi kopija ( primer (copy).xxx )
                  fileName=fileName.partition('.')
                  copyName=fileName[0]+" (copy)"+fileName[1]+fileName[2]
                  self.filePath = self.dwnDir+copyName              

               else:
                  self.filePath = self.dwnDir+fileName

               self.fp = open(self.filePath,'w')

               self.dwn_size = 0
               #pravi se tajmer za download
               self.dwnTimer = gobject.timeout_add(250, self.downloadTimer250ms)

            return False
            
         else:
            self.s-=1

            text = "Free RapidShare user must wait..."
            self.statusBar.push(0,text)

            if self.s > 59:
               self.progressbar.set_text(str(self.s/60) + " m   "+str(self.s%60)+" s...")
            else:
               self.progressbar.set_text(str(self.s%60)+" s...")
            self.setTreeView(self.treemodel, self.iter, 0, "Waiting...")
            self.progressbar.set_fraction(1-self.s/float(seconds))

      return True
         
#-----------------------------------------------------------------------------------

   def badLink_connectionProblem_loadNext(self,):
      # u sluchaju losheg linka ili nekog problema prebacuje se na sledeci link

      self.progressbar.set_fraction(0)
      pom_iter = self.setTreeView(self.treemodel, self.iter, 0, "Error!")
      # ovde treba prebaciti na sledeci link ako ima
      try:
         self.objekat.br.close()
         del self.objekat
      except:
         pass
      self.progress = False
      prviSpremniLink = self.findFirstLink()
      if prviSpremniLink>-1:
         self.links[prviSpremniLink][1]="2"

         if not pom_iter == None:
            self.iter = pom_iter
            self.buttonDownload()
#-----------------------------------------------------------------------------------

   def zavrsiDownloadPrebaciNaSledeci(self):
      #brishe se ovaj tajmer
      try:
         # oslobadjanje tajmera
         gobject.source_remove(self.dwnTimer)
         del self.dwnTimer
      except:
         pass

      self.statusBar.push(0,"Finished!")
      self.progressbar.set_text("Finished!")

      pom_iter = self.setTreeView(self.treemodel, self.iter, 100, "Finished!")
      # ovde treba prebaciti na sledeci link ako ima
      self.fp.close()
      self.objekat.br.close()
      del self.objekat
      self.progress = False
      prviSpremniLink = self.findFirstLink()
      if prviSpremniLink>-1:
         self.links[prviSpremniLink][1]="1"

         if not pom_iter == None:
            self.iter = pom_iter
        #    del self.objekat
            self.buttonDownload()
         #else:
         #   del self.objekat
      #else:
      #   del self.objekat

#-----------------------------------------------------------------------------------

   def convertByte(self, bytes):
      # Konvertuje bytes u KB/MB/GB
      
      if long(bytes) >= (1024*1024*1024): 
         return str("%.2f" %(float(bytes) / 1073741824)) + " GB "

      elif  long(bytes) >= (1024*1024): 
         return str("%.2f" %(float(bytes) / 1048576)) + " MB "

      elif  long(bytes) >= (1024): 
         return str("%.2f" %(float(bytes) /1024)) + " KB "

      else:
         return bytes+" B "
#-----------------------------------------------------------------------------------

   def aboutShow(self, event=0):
      # prikazuje about ekran

      self.aboutWindow = self.wTree.get_widget("aboutWindow")
      response = self.aboutWindow.run()
      if response == gtk.RESPONSE_YES:
         os.system("xdg-open http://www.njsoft.iz.rs")

      self.aboutWindow.hide()#destroy()

      return False

#-----------------------------------------------------------------------------------

   def homepageOpen(self, event=0):
      # otvara default internet browser i njsoft stranicu
      os.system("xdg-open http://www.njsoft.iz.rs")
#-----------------------------------------------------------------------------------

   def getBetween(self, data, first, last):
      x = len(first)
      begin = data.find(first) +x
      end = data.find(last, begin)
      return data[begin:end]
#-----------------------------------------------------------------------------------

if __name__ == "__main__":
   hwg = Baltazar()
   hwg.run()
