#!/usr/bin/env python
#     ________________________________________________
#    /_______________________________________________/|
#    |                                              |*|
#    |   name:         rapid.py                     |*|
#    |   version:      0.2                          |*|
#    |   Last Change:  28. July 2009.               |*|
#    |                                              |*|
#    |   made by:      Jovicic Nemanja (c) 2008.    |*|
#    |   email:        nemanja.jovicic@hotmail.com  |*|
#    |   homepage:     http://www.njsoft.iz.rs      |*|
#    |                                              |*|
#    |   made in Serbia                             |*|
#    |______________________________________________|/

# todo:
# * obrisati sve funkcije koje se ne koriste
# * ako je moguce vratiti broj sekundi cekanja
# * zavrsiti funkciju cekanja 15 minuta

try:
   import re
   import time
   import sys
   import os

   from threading import Timer
except:
   print "Check dependencies! Import library error!"
   exit(1)

try:
   from mechanize import Browser
except:
   print "\nDependencies error! Depends on python-mechanize library.\n"
   exit(1)   
   
   
class Rapid:

   
   def proslediLink(self, url, dwnDir):
      # pocetna funkcija koja se poziva iz glavnog programa
      # povratne vrednosti:
      #  [0, IP] - sluchaj kada se vec preuzima sa ip adrese
      #  [x, s ] - stanje servera, broj sekundi chekanja
      #  [-1,-1] - greshka
      
      #pravi se instanca mechanize.Browser
      self.br = Browser()
      try:
         #borwser otvara link
         self.br.open(url)
      
         #selektujemo free formu
         self.br.select_form(nr=0)
      
         #klik na free dugme
         response = self.br.submit()
      
         #smestamo kompletan html tekst u promenljivu html
         html = response.read()

      except:
         self.br.close()
         del self.br
         return [-1, -1]
      
      htmlDec = self.urldecode(html)
      serverRespond = self.checkServer(htmlDec)

      self.htmlDec=htmlDec
      self.serverRespond=serverRespond
      self.dwnDir=dwnDir
      #print "Server respond: " +str(serverRespond)
      
      if serverRespond == 1:
         #ovo u glavnom treba da izbaci notifikaciju i da nastavi sa sledecim linkom...
         self.br.close()
         del self.br      
         return [0, self.getIP(htmlDec)]

      elif serverRespond < 1:
         self.br.close()
         del self.br
         return [-1, -1]

      else: #serverRespond 2, 3, 4
         return [serverRespond, self.getSeconds(htmlDec,serverRespond)]     
         
#-----------------------------------------------------------------------------------     

   def checkServer(self,htmlDec):
      # funkcija proverava stanje servera
      # povratne vrednosti:
      # -1 - adresa nije dobro uneta
      #  1 - vec se skida fajl sa korisnickog IP-a
      #  2 - server preopterecen, ceka se 2 min
      #  3 - treba cekati onih 15-ak minuta
      #  4 - treba cekati onih 50ak sekundi
      # -1 - nije otvorena prava stranica, doslo je do neke greske

      if htmlDec=="":
         return -1 

      IP = re.search('Your IP address ', htmlDec)
      if not IP == None:
         return 1
            
      respond = re.search('Currently a lot of users are downloading files.', htmlDec)
      if not respond == None:
         return 2

      respond = re.search('Instant download access! Or try again in about', htmlDec) 
      if not respond == None:
         return 3

      respond = re.search('You are not a Premium User and have to wait.', htmlDec)
      if not respond == None:
         return 4
   
      return -1
      
#-----------------------------------------------------------------------------------

   def getIP(self,htmlDec):
      # vraca IP adresu u koliko se desi situacija da se neki fajl vec preuzima
      # sa korisnickog IP-a
      
      return self.getBetween(htmlDec, 'Your IP address ', ' is already downloading a file.')
#-----------------------------------------------------------------------------------

   def getBetween(self, data, first, last):
      # vraca tekst iz DATA koji se nalazi izmedju FIRST i LAST
            
      x = len(first)
      begin = data.find(first) +x
      end = data.find(last, begin)
      return data[begin:end]
#-----------------------------------------------------------------------------------


   def htc(self, m):
      # ne znam sta radi
      return chr(int(m.group(1), 16))


   def urldecode(self, url):
      # vraca dekodovanu html stranicu
      
      rex=re.compile('%([0-9a-hA-H][0-9a-hA-H])', re.M)
      return rex.sub(self.htc, url)
#-----------------------------------------------------------------------------------

   def getSeconds(self, htmlDec, serverState):
      # vraca broj sekundi u zavisnosti od stanja servera
      # -1 u slucaju greske
      
      if serverState == 2:
         return 120
         
      elif serverState == 3:
         return int(self.getBetween(htmlDec, 'Or try again in about ', ' minutes.'))*60

      elif serverState == 4:
         return int(re.search('var c=[0-9]*',htmlDec).group(0)[6:])

      else:
         return -1
#-----------------------------------------------------------------------------------
      
   def fileDownload(self, htmlDec):
      # Funkcija za download fajla
      # htmlDec - ucitani sadrzaj html fajla
      
      #trazimo download link koristeci regular expresions
      try:
         url = re.search('action="http://[^"]*', htmlDec).group(0)[8:]
         self.file = self.br.open(url)
      except:
         return "Error"

      self.file_size = self.file.info().getheader("Content-Length")
      self.fileName = url.split('/')[-1]

      return "Ok"
#-----------------------------------------------------------------------------------

   def getTypeImage(self,link):
      # vraca ucitanu ikonicu
      import gtk  
      from sys import argv
      if argv[0].find('/') == argv[0].rfind('/'):
         path =""
      else:
         path = argv[0][:argv[0].rfind('/')].strip()+'/'

      ext = link[link.rfind(".")+1:]
      #sad treba ifovi za podrzane extenzije...
      
      if ext!="rar" and ext!="zip" and ext!="tar" and ext!="gz" and ext!="mp3" and ext!="wma" and ext!="avi":
         ext="unk"
      return gtk.gdk.pixbuf_new_from_file(path+"types/"+ext+".png")
#-----------------------------------------------------------------------------------

   def getImeFajla(self, link):
      # vraca ime fajla

      ime = link[link.rfind("/")+1:]
      if len(ime)>13:
         pIme=ime[0:5]+"..."+ime[len(ime)-7:]
         ime=pIme
      return str(ime)
#-----------------------------------------------------------------------------------


#if __name__ == "__main__":
#   tmp=Rapid()
#   tmp.proslediLink("http://rapidshare.com/files/136295384/Python_Cookbook.pdf","/home/drxnele/Desktop/")

         

