#!/usr/bin/env python
#     ________________________________________________
#    /_______________________________________________/|
#    |                                              |*|
#    |   name:         youtube.py                   |*|
#    |   version:      0.1                          |*|
#    |   Last Change:  29. July 2009.               |*|
#    |                                              |*|
#    |   made by:      Jovicic Nemanja (c) 2008.    |*|
#    |   email:        nemanja.jovicic@hotmail.com  |*|
#    |   homepage:     http://www.njsoft.iz.rs      |*|
#    |                                              |*|
#    |   made in Serbia                             |*|
#    |______________________________________________|/

try:
   import re
   import time
   import sys
   import os

except:
   print "Check dependencies! Import library error!"
   exit(1)

try:
   from mechanize import Browser
   import mechanize
except:
   print "\nDependencies error! Depends on python-mechanize library.\n"
   exit(1)   
   
   
class Youtube():

   # posle konstruktora treba da se bira extenzija
   ext=".flv"
   
   def proslediLink(self, url, dwnDir):

      url = self.youtubeUrlToLinkYoutube(url)
      try:
      
         # ucitavanje url-a
         response = mechanize.urlopen(url)
      
         #smestamo kompletan html tekst u promenljivu html
         html = response.read()

      except:
         return 0

      htmlDec = self.urldecode(html)
      
      url = self.findVideoLink(htmlDec,self.ext)
      if url == -1:
         print 'Link error'
         return -1

      self.fileName = self.findVideoName(htmlDec, self.ext)

      return self.fileDownload(url)
#-----------------------------------------------------------------------------------
      
   def youtubeUrlToLinkYoutube(self, url):
      # pretvara youtube link u linkyoutube link zbog downloada
      
      [a, b] =url.split ( "youtube" )
      return a+"linkyoutube"+b       
#-----------------------------------------------------------------------------------      
   
   def getBetween(self, data, first, last):
      # vraca tekst iz DATA koji se nalazi izmedju FIRST i LAST
            
      x = len(first)
      begin = data.find(first) +x
      end = data.find(last, begin)
      return data[begin:end]
#-----------------------------------------------------------------------------------

   def htc(self, m):
      # ne znam sta radi
      return chr(int(m.group(1), 16))


   def urldecode(self, url):
      # vraca dekodovanu html stranicu
      
      rex=re.compile('%([0-9a-hA-H][0-9a-hA-H])', re.M)
      return rex.sub(self.htc, url)
#-----------------------------------------------------------------------------------

   def findVideoLink(self, htmlDec, ext):
      # pronalazi link ka videu
      
      if ext == ".mp4":      
         return self.getBetween(htmlDec,'flv File </font></a><br> <a href="','"><font color="blue" size="4">Download MP4')
      elif ext == ".flv":
         return self.getBetween(htmlDec,'<div class="dwlurl" id ="dwlurl"><a href="','"><font color="blue" size="4">Download .flv')
      else:
         return -1
      
#-----------------------------------------------------------------------------------

   def findVideoName(self, htmlDec, ext):
      # pronalazi ime videa
      # ext - extenzija (flv ili mp4)
      
      return self.getBetween(htmlDec,'<title>Linkyoutube - Download','</title><b><font size="4">')+ext
#-----------------------------------------------------------------------------------

   def fileDownload(self, url):
      # Funkcija za zapochinjanje downloada koja vraca "Ok" ako je uspeshno zapocheto
      # url - adresa linka
      
      self.br=Browser()
      try:
         self.file = self.br.open(url)
      except:
         return "Error"
      self.file_size = self.file.info().getheader("Content-Length")


      return "Ok"   

#-----------------------------------------------------------------------------------

   def setExt(self, ext):
      # ova metoda se poziva iz glavnog programa da bi se izabrala extenzija
      # default extenzija je ".flv"
      
      self.ext=ext
#-----------------------------------------------------------------------------------

   def getTypeImage(self,link):
      # vraca ucitanu ikonicu
      import gtk
      from sys import argv
      if argv[0].find('/') == argv[0].rfind('/'):
         path =""
      else:
         path = argv[0][:argv[0].rfind('/')].strip()+'/'

      return gtk.gdk.pixbuf_new_from_file(path+"types/youtube.png")
#-----------------------------------------------------------------------------------

   def getImeFajla(self, link):
      # vraca ime fajla

      return "Youtube video"
#-----------------------------------------------------------------------------------

#if __name__ == "__main__":
#   tmp=Youtube()
#   tmp.proslediLink("http://www.youtube.com/watch?v=YtmFM3nsYlQ","/home/drxnele/Desktop/")        

